//RahmenEntketten_301d.js
// 06.06.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Hebt die Verkettungen auf

//Credits: Inspiriert von "SplitStory.jsx" (an InDesign CS5 JavaScript)

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// das Dokument im Vordergrund
var curDoc = app.documents[0];

// die Auswahl
var appSel = app.selection;
var nSel   = appSel.length;
if (nSel  == 0) {
	alert ("Es ist nichts ausgewhlt.", "Stop");
	exit();
}

// einen Array vorbereiten
var storyIDs = new Array ();
// eine Schleife durch die Auswahl
for (var s=0; s<nSel; s++) {
	// das aktuelle Element der Auswahl
	curSel = appSel[s];
	// prfen, ob die Bedingungen erfllt sind
	if (curSel.hasOwnProperty("baseline") || curSel.constructor.name == "TextFrame") {
		// die ID der aktuellen Textkette
		var curID = curSel.parentStory.id;
		// die Funktion aufrufen, welche die Nummer prft
		if (!checkID(storyIDs, curID)) {
			// wenn noch nicht bekannt, dann die Liste ergnzen
			storyIDs.push(curID);
		}
	}
}

// die Anzahl IDs
var nIDs = storyIDs.length;
if (nIDs == 0) {
	alert ("Keine Textkette ausgewhlt.", "Achtung");
	exit();
} 

// ein Zhlervariable initialisieren
var sCtr = 0;
// eine Schleife durch die Textketten
for (var i=0; i<nIDs; i++) {
	curID = storyIDs[i];
	var curStory = curDoc.stories.itemByID(curID);
	// nur wenn die Textkette durch mehrere Textrahmen fliesst
	if (curStory.textContainers.length > 1) {
		// die Funktion aufrufen, welche die Rahmen dupliziert
		splitStory(curStory);
		// die Funktion aufrufen, welche die Original-Rahmen lscht
		removeFrames(curStory);
		sCtr++;
	}
}

// das Ende der Aktion verknden
if (sCtr > 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	// eine kleine Pause
	$.sleep(999);
	// das Fenster schliessen
	dlog.close();
}
else {
	alert ("Eine Textkette muss mindestens von einem Rahmen in einen zweiten fliessen.", "Aufgepasst!");
}

// die Funktionen /////////////////////////////////////////////////////////////////////////////////

// prfen, ob die ID schon im Array ist
function checkID(storyIDs, curID) {
	for (var i=0; i<storyIDs.length; i++) {
		if (storyIDs[i] == curID) {
			return true;
		}
	}
	return false;
}

// die Textrahmen duplizieren
function splitStory(curStory) {
	// die Schleife luft rckwrts
	for(var ctr=curStory.textContainers.length-1; ctr>-1; ctr--){
		curStory.textContainers[ctr].duplicate();
	}
}

// die Originalrahmen entfernen
function removeFrames(curStory) {
	// mit einer Rckwrtschleife die Rahmen aufsuchen
	for (var ctr=curStory.textContainers.length-1; ctr>-1; ctr--) {
		// der aktuelle Rahmen ...
		var curFrame = curStory.textContainers[ctr];
		try {
			// ... wird vorsorglich entsperrt ...
			curFrame.locked = false;
			// ... und entfernt
			curFrame.remove();
		}
		catch (e) {
		}
	}
}